;**************************************************************
;    Operno
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************
;DEUTSCH:
;  WICHTIG:
;    Die DLL im Ordner "Operno\Operno.dll" muss in den Ordner
;    des jeweiligen Projekts kopiert werden.
;    Falls sich die DLL nicht im Hauptordner befindet, muss der
;    korrekte Pfad in "InitOperno([Path.s])" angegeben werden.



CompilerIf Defined(Operno_PBI, #PB_Constant) = #False
#Operno_PBI = #True



IncludeFile #PB_Compiler_FilePath + "Operno\Operno.pbi"



;******************************************
; Examples
;******************************************
;DEUTSCH:
;  HINWEIS: Muss fr die Beispiele auskommentiert sein!:

; InitOperno(#PB_Compiler_FilePath + "Operno\Operno.dll")

;{ Evaluations
;   Debug OpernoEvalI("1 + 1")        ;= 2
;   Debug OpernoEvalI("4 + 10")     ;= 116
;   Debug OpernoEvalI("0.5(6 + 2*3)") ;= 6
;}
;{ Variables
;   OpernoEval("x = 11")
;   Debug OpernoVariableI(OpernoGet("x"))
;   
;   OpernoCreateIVariable("y", OpernoEvalI("2x"))
;   Debug OpernoEvalI("y - 2")
;}
;{ Groups
;   Code$ = "user{"                                    + Chr(10)
;   Code$ + "  name  = " + Chr(34) + "Josef" + Chr(34) + Chr(10)
;   Code$ + "  age   = 16"                             + Chr(10)
;   Code$ + "  hobby = " + Chr(34) + ";)" + Chr(34)    + Chr(10)
;   Code$ + "}"
;   
;   OpernoEval(Code$)
;   
;   ; Scan:
;   User  = OpernoGet("user")
;   Child = OpernoFirstChild(User)
;   
;   While Child
;     If OpernoObjectType(Child) = #OpernoObject_Variable
;       Value = OpernoVariableValue(Child)
;       Select OpernoValueClass(Value)
;         Case *OpernoIntegerClass
;           Debug OpernoValueI(Value)
;         Case *OpernoStringClass
;           Debug OpernoValueS(Value)
;       EndSelect
;     EndIf
;     Child = OpernoNextObject(Child)
;   Wend
;}
;{ Functions
;   Procedure.i Fak()
;     Protected N.i, Result.i
;     
;     If OpernoPopIValue(@N) ;Get an argument.
;       Result = 1
;       While N > 1
;         Result * N
;         N - 1
;       Wend
;       ProcedureReturn OpernoPushIValue(Result) ;Push the result.
;     Else
;       _OpernoArgumentError(1) ;Raise an error!
;     EndIf
;   EndProcedure
;   
;   OpernoCreateFunction("fak", @Fak())
;   
;   Debug OpernoEvalI("fak(5)")
;   
;   
;   
;   Procedure.i SayHello()
;     Protected Name.String, Age.i
;     
;     If OpernoPopSValue(@Name) And OpernoPopIValue(@Age)
;       MessageRequester("Message", "Hello, my name is " + Name\S + "." + Chr(10) + "I'am " + Str(Age) + " years old.")
;     Else
;       _OpernoArgumentError(2)
;     EndIf
;   EndProcedure
;   
;   OpernoCreateFunction("sayHello", @SayHello())
;   
;   ; In Operno you can write indentifers with spaces:
;   OpernoEval("say hello(" + Chr(34) + "Josef" + Chr(34) + ", 16)")
;}



CompilerEndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 111
; FirstLine = 78
; Folding = -
; EnableXP